﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Micro.Controllers
{
    [HandleError]
    public class HomeController : Controller
    {
        public ActionResult Index(string channel, string name)
        {
            var svc = new Models.MicroData();
            
            ViewData["channels"] = svc.Channels;

            var q = from m in svc.Messages
                    where m.PartitionKey == Models.Message.MakeKey(channel, DateTime.UtcNow)
                    select m;

            if (!string.IsNullOrEmpty(name))
                q = from m in q
                    where m.Author == name
                    select m;

            ViewData["msg"] = q;

            return View();
        }

        public ActionResult PostMessage(string channel, string author, string msg)
        {
            var svc = new Models.MicroData();

            var q = from c in svc.Channels
                    where c.PartitionKey == channel
                    select c;

            if (q.FirstOrDefault() == null) throw new ArgumentException("Invalid Channel");

            var m = new Models.Message(channel, author, msg);

            svc.AddObject("Messages", m);

            svc.SaveChanges();

            return this.RedirectToAction("Index");

        }

        public ActionResult About()
        {
            return View();
        }
    }
}
